/////////////////////////////////////////////////////////////////////
//HangulConversion.java				/////////////////////////////////
/////////////////////////////////////////////////////////////////////
import java.sql.*;
import java.io.*;
public class HangulConversion {
	private static final String version = "8.1.5.0.0";
	private static final boolean NO_CONVERT = true;
//	private static final boolean convert = NO_CONVERT;
        /** Unicode 2.0 --> Unicode 1.2 */
public static String toDB (String uni20) throws SQLException {
     if (uni20 == null)
       return null;
     int len = uni20.length();
     char [] out = new char[len];
     for (int i = 0; i < len ; i++) {
       char c = uni20.charAt(i);
       if (c < 0xac00 || c > 0xd7a3 ) {
           out[i] = c;
       } else { // Unicode 2.0 ѱڵ 
        try {
          byte [] ksc = String.valueOf(c).getBytes("KSC5601");
          if (ksc.length != 2) {
            out[i] = '\ufffd';
            System.err.println ("Warning : Some of Unicode 2.0 Hangul Character was ignored.");
          } else {
            out[i]= (char) (0x3400 + ((ksc[0] & 0xff) - 0xb0) * 94 + (ksc[1] & 0xff) - 0xa1);
          }
        } catch (java.io.UnsupportedEncodingException ex) {
           throw new SQLException (ex.getMessage());
        }
     }
     }
    return new String (out);
}
        
        /** Unicode 1.2 --> Unicode 2.0 */
public static String fromDB (String uni12) throws SQLException {
 if (uni12 == null)
   return null;
 int len = uni12.length();
 char [] out = new char[len];
 byte [] ksc = new byte [2];
 for (int i = 0; i < len ; i++) {
   char c = uni12.charAt(i);
   if (c < 0x3400 || c > 0x4dff) {
      out[i] = c;
   } else if (c >= 0x3d2e) { // Unicode 1.2 ѱ 濵 A, B
      out[i] = '\ufffd';
      System.err.println ("Warning : Some of Unicode 1.2 Hangul Character was ignored.");
   } else { // Unicode 1.2 KSC5601  ѱ 
     try {
       ksc[0] = (byte) ((c - 0x3400) / 94 + 0xb0);
       ksc[1] = (byte) ((c - 0x3400) % 94 + 0xa1);
       out[i] = new String(ksc, "KSC5601").charAt (0);
     } catch (java.io.UnsupportedEncodingException ex) {
       throw new SQLException(ex.getMessage());
     }
   }
 }
 return new String (out);
}

 // "KSC5601" code "8859_1" code encoding
public static String toEng (String ko) throws SQLException {
		return toEng(ko, NO_CONVERT);
}
public static String toEng (String ko, boolean convert) throws SQLException {
		if (convert) {
			if (ko == null) {
				return null;
			}
			String new_str = null;
			try {
				new_str=new String(ko.getBytes("KSC5601"),"8859_1");
			} catch(UnsupportedEncodingException ex) { 
					throw new SQLException(ex.getMessage());
			}
			return new_str;
		} else {
			return ko;
		}
}

 // "8859_1" code "KSC5601" code encoding
public static String toKor (String en) throws SQLException{
		return toKor(en, NO_CONVERT);
}
public static String toKor (String en, boolean convert) throws SQLException{
		if (convert) {
			if (en == null) {
				return null;
			}
    		String new_str = null;
    		try {
    		    new_str = new String (en.getBytes("8859_1"), "KSC5601");
			} catch (UnsupportedEncodingException ex) {
					throw new SQLException(ex.getMessage());
			}
    			return new_str;
		    } else {
			return en;
		}
}
}
